
#pragma once
#include "shm_config.h"
namespace bg
{
    namespace detail
    {
        template<typename T>
        class MetadataAllocator
        {
        public:
            MetadataAllocator()
            {
                static_assert(sizeof(T) >= sizeof(void*), "type T too small");
            }
            void Destroy(T* free)
            {
                *(void**)free = m_free_list;
                m_free_list = free;
            }

            T* Allocate()
            {
                T* free = reinterpret_cast<T*>(m_free_list);
                if(free)
                {
                    m_free_list = *(void**)free;
                    return free;
                }

                if(m_free_left >= sizeof(T))
                {
                    free = (T*)m_free_area;
                    m_free_left -= sizeof(T);
                    m_free_area += sizeof(T);
                    return free;
                }

                size_t bytes = AREA_SIZE;
                T* free_area = reinterpret_cast<T*>(bg::detail::ShmAllocateRawMemory(&bytes, PAGE_BYTES));

                if(free_area)
                {
                    free = free_area;
                    m_free_area = reinterpret_cast<char*>(&free_area[1]);
                    m_free_left = bytes - sizeof(T);
                }
                return free;
            }
        private:
            void* m_free_list{};
            char* m_free_area{};
            size_t m_free_left{};
        };
    }
}
